#!/usr/bin/php
<?php


// Funktionsbeschreibung im m23-Stil auf English
$modi['fctdesc'] =
	array(
	"startFenster" => "Engl. Funktionsbeschreibung erstellen",
	"endeFenster" => "Funktionsbeschreibung",
	"ladeTxt" => false,
	"prompt" => "Kommentiere eine PHP-Funktion mit einem Header.

Beispiel, wie ein solcher Header aussehen soll:

/**
**name CLIENT_getLDAPProtocol(\$clientOptions)
**description Gets the LDAP access protocol (ldap or ldaps) by client's options.
**parameter clientOptions: the client's options array
**returns LDAP access protocol.
**/
function CLIENT_getLDAPProtocol(\$clientOptions)
{
	if (isset(\$clientOptions['ldapTLS']))
		return('ldaps');
	else
		return('ldap');
}

Erstelle den Header für die folgende Funktion auf Englisch. In der '**name'-Zeile sollen die Parameter enthalten sein:
"
);



// In PHP programmieren
$modi['prgphp'] =
	array(
	"startFenster" => "Programmiere in PHP",
	"endeFenster" => "PHP-Code",
	"ladeTxt" => true,
	"prompt" => "programmiere in php:"
);






// Erstellt ein Array mit den Namen der Modi aus dem $modi-Array
$modusNamen = array_keys($modi);

// Überprüft, ob genau ein Kommandozeilenargument übergeben wurde und ob es einen verfügbaren Modi enthält
if (($argc != 2) || !isset($modi[$argv[1]]))
{
	echo('ERROR
' . $argv[0] . ' <mode>
');

	// Gibt die verfügbaren Modi aus
	print_r($modusNamen);

	// Beenden mit Fehlercode 1
	exit(1);
}

// Aktueller Modus
$modus = $modi[$argv[1]];

// Ein- und Ausgabedateinamen festlegen
$einDatei = '/tmp/AI-In.txt';
$ausDatei = '/tmp/AI-Out.txt';


// Ggf. Eingabetext aus vorheriger Sitzung laden
$eingabeText = ($modus['ladeTxt'] && file_exists($einDatei)) ? file_get_contents($einDatei) : '';

// Eingabetext eingeben
exec('kdialog --caption "'.$modus['startFenster'].'" --geometry 800x600 --icon kate --textinputbox Eingabe: "'.$eingabeText.'" 10 25 > '.$einDatei);

// Eingabetext speichern
$eingabeText = file_get_contents($einDatei);

if (strlen($eingabeText) < 2) die('Nichts angegeben :-(');


// Array für die KoboldCPP-Anfrage zusammenstellen
$data = [
"max_context_length" => 2048,
"max_length" => 500,
"prompt" => "$modus[prompt]
$eingabeText",
"quiet" => false,
"rep_pen" => 1.1,
"rep_pen_range" => 256,
"rep_pen_slope" => 1,
"temperature" => 0.7,
"tfs" => 1,
"top_a" => 0,
"top_k" => 100,
"top_p" => 0.9,
"typical" => 1
];


// Daten per curl als JSON an KoboldCPP senden
$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, "http://localhost:5001/api/v1/generate");
curl_setopt($curl, CURLOPT_POST, true);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
curl_setopt($curl, CURLOPT_HTTPHEADER, array(
"Content-Type: application/json",
"Content-Length: ".strlen(json_encode($data))
));


// JSON in Array umwandeln und nur den Antworttext von KoboldCPP verarbeiten
$response = curl_exec($curl);
$response_a = json_decode((string)$response, true);
$text = $response_a["results"][0]['text'];

// Suchen, ob "</think>" gibt, der das Ende des Denkprozesses des Netzes markiert
$textStartPos = strpos($text, '</think>');

// Wurde eine Position gefunden, so nur den Text nach "</think>" weiterverarbeiten
if ($textStartPos !== false)
	$text = substr($text, $textStartPos + 8);



// Zerlege den Text in Zeilen
$lines = explode("\n", trim($text));
$text = '';
// Zeilen durchlaufen
foreach ($lines as $line)
{
	if (!preg_match("/^```\$/", $line))
		$text .= "$line\n";
}

file_put_contents($ausDatei, trim($text));

exec('kdialog --caption "'.$modus['endeFenster'].'" --geometry 800x600 --icon kate --textbox "'.$ausDatei.'" 80 25');
?>